class iaas::profile::ceilometer::common (
  $secret = hiera('iaas::profile::ceilometer::secret', undef),

  $password = hiera('iaas::profile::ceilometer::password', undef),
  $region = hiera('iaas::region', undef),

#VIP1
  $endpoint_main = hiera('iaas::main_address', undef),
#VIP2
  $endpoint_admin = hiera('iaas::admin_address', undef),

##rhosts
#  $endpoint = hiera('iaas::main_address', undef),
  $rhosts = hiera('iaas::profile::rabbitmq::rhosts', undef),
  $rabbitmq_user = hiera('iaas::profile::rabbitmq::user', undef),
  $rabbitmq_password = hiera('iaas::profile::rabbitmq::password', undef),
) {

  if $endpoint_admin == '' {
    $real_endpoint_admin = $endpoint_main
  }else{
    $real_endpoint_admin = $endpoint_admin
  }

  class { '::ceilometer':
    metering_secret => $secret,
##rabbit_hosts - uncomment as needed
#    rabbit_hosts => [ $endpoint ],
    rabbit_hosts => $rhosts,
    rabbit_userid => $rabbitmq_user,
    rabbit_password => $rabbitmq_password,
  }

  class { '::ceilometer::agent::auth':
    auth_url => "http://${endpoint_main}:5000/v2.0",
    auth_password => $password,
    auth_region => $region,
  }

  ceilometer_config {
    'keystone_authtoken/identity_uri' :value => "http://${real_endpoint_admin}:35357";
  }

## Change default polling interval from 10min to 0.5m for all sources
#  exec { 'ceilometer_pipeline_interval':
#    command => "sed -i 's/interval: 600$/interval: 30/' /etc/ceilometer/pipeline.yaml",
#  }
}
